<script setup lang="ts">
import {
  GeneOverview,
  GOAnnotationCRUD,
  PublicationCRUD,
  PhenotypeCRUD,
  IBScreen,
  OrthologyPanel,
} from "#components";

const gene = toValue(useCurrentGene());
if (!gene) {
  throw createError("No gene is provided");
}

const { fetchIBs } = useGeneService();
const { fetchByGene: fetchPhenotypesByGene } = usePhenotypeService();

const { data } = await useAsyncData(`details-${gene}`, () =>
  Promise.all([fetchIBs(gene), fetchPhenotypesByGene(gene)]),
);
const [dsRNAs, phenotypes] = [...(data.value || [])];
provide(iBeetleDsRNAsKey, dsRNAs || []);

const communityPhenotypes =
  phenotypes === undefined
    ? undefined
    : phenotypes.filter((p) => !p.iBeetleExperiment);
const iBeetlePhenotypes =
  phenotypes === undefined
    ? undefined
    : phenotypes
        .filter((p) => p.iBeetleExperiment)
        .reduce(
          (acc, p) => {
            const dsRNAName = p.dsRNA.name || "Unknown";
            if (acc[dsRNAName]) {
              acc[dsRNAName].push(p);
            } else {
              acc[dsRNAName] = [p];
            }
            return acc;
          },
          {} as Record<
            string,
            Awaited<ReturnType<typeof fetchPhenotypesByGene>>
          >,
        );

const panels = [
  {
    header: "Overview",
    component: GeneOverview,
    props: {
      gene,
    },
  },
  {
    header: "Closest fly homologs",
    component: OrthologyPanel,
    props: {
      gene,
    },
  },
  {
    header: "Gene ontology",
    component: GOAnnotationCRUD,
    props: {
      gene,
    },
  },
  {
    header: "Publications",
    component: PublicationCRUD,
    props: {
      gene,
    },
  },
  {
    header: "RNAi phenotypes contributed by the community",
    shortHeader: "Community phenotypes",
    component: PhenotypeCRUD,
    props: {
      gene,
      phenotypes: communityPhenotypes,
    },
  },
  ...(dsRNAs || []).map((dsrna) => ({
    header: `RNAi phenotypes from iBeetle screen ${dsrna.id}`,
    shortHeader: `iBeetle screen ${dsrna.id}`,
    component: IBScreen,
    props: {
      dsrna,
      phenotypes: iBeetlePhenotypes?.[dsrna.id] || [],
    },
  })),
];

const hash = ({
  header,
  shortHeader,
}: {
  header: string;
  shortHeader?: string;
}) => {
  return stringToURLHash(shortHeader || header);
};

const { items: rightNavigatorItems } = storeToRefs(useRightNavigatorStore());
const updateRightNavigatorItems = () => {
  rightNavigatorItems.value = panels.map((panel) => ({
    title: panel.shortHeader || panel.header,
    hash: hash(panel),
  }));
};

onMounted(updateRightNavigatorItems);
onActivated(updateRightNavigatorItems);
</script>

<template>
  <v-container v-if="gene" class="pa-0">
    <TopLevelPanelWrapper
      v-for="panel in panels"
      :key="panel.header"
      :header="panel.header"
      :hash="hash(panel)"
    >
      <component :is="panel.component" v-bind="panel.props" />
    </TopLevelPanelWrapper>
    <WarningAlert
      v-if="dsRNAs === undefined || iBeetlePhenotypes === undefined"
      :text="`Failed to fetch iBeetle RNAi phenotypes for gene ${gene}`"
    />
  </v-container>
</template>
